<?php
namespace app\maccms\event;

class Sql
{
    /**
    * 安装时触发/通常用于数据库操作
    * @return bool 只有返回true时才会往下执行
    */
	public function install()
    {
        //批量添加配置
        model('maccms/Datas')->insertConfig();
        
        //批量添加路由
        model('maccms/Datas')->insertRoute();
        
        //批量添加分类
        model('maccms/Datas')->insertCategory();
        
        //清空缓存
        \think\Cache::clear();
        
        return true;
	}
    
    /**
    * 升级时触发/通常用于数据库操作
    * @return bool 只有返回true时才会往下执行
    */
    public function upgrade()
    {
        //更新MACCMS基础信息
        $result = \daicuo\Apply::updateStatus('maccms', 'enable');
        if(!$result){
            return false;
        }
        
        //更新应用打包配置
        $result = \daicuo\Op::write([
            'apply_version' => '1.4.15',
        ]);
        if(!$result){
            return false;
        }
        
        return true;
	}
    
    /**
    * 卸载插件时触发
    * @return bool 只有返回true时才会往下执行
    */
    public function remove()
    {
        return $this->unInstall();
    }
    
    /**
    * 删除插件时触发
    * @return bool 只有返回true时才会往下执行
    */
    public function unInstall()
    {
        //删除插件配置
        \daicuo\Op::delete_module('maccms');
        
        //删除插件分类
        \daicuo\Term::delete_module('maccms');
        
        return true;
	}
	
}