<?php
namespace app\maccms\model;

class Datas
{
    //批量写入插件初始配置
    public function insertConfig()
    {
        //首页轮播
        $slide_index = [
            ['title'=>'MacCms','image'=>'https://cdn.daicuo.cc/images/slide/01.jpg','url'=>'http://www.maccms.co','describe'=>''],
            ['title'=>'MacCms','image'=>'https://cdn.daicuo.cc/images/slide/02.jpg','url'=>'http://www.maccms.co','describe'=>''],
            ['title'=>'MacCms','image'=>'https://cdn.daicuo.cc/images/slide/03.jpg','url'=>'http://www.maccms.co','describe'=>''],
            ['title'=>'MacCms','image'=>'https://cdn.daicuo.cc/images/slide/04.jpg','url'=>'http://www.maccms.co','describe'=>''],
            ['title'=>'MacCms','image'=>'https://cdn.daicuo.cc/images/slide/05.jpg','url'=>'http://www.maccms.co','describe'=>''],
        ];
        //友情链接
        $link_index = [
            ['title'=>'MacCms','url'=>'https://www.maccms.co','target'=>'_blank','describe'=>''],
            ['title'=>'DaiCuo','url'=>'http://www.daicuo.net','target'=>'_blank','describe'=>''],
        ];
        //底部链接
        $link_footer = [
            ['title'=>'2022免费电影','url'=>'http://www.maccms.co','target'=>'_blank','describe'=>'提供2022年上映的免费电影，即不收费就可观看和下载的电影。'],
            ['title'=>'2022最新电影','url'=>'http://www.maccms.co','target'=>'_blank','describe'=>'提供2022年高清电影，2022年最新电视剧，好看的免费高质量影片。'],
            ['title'=>'2022好看电影','url'=>'http://www.maccms.co','target'=>'_blank','describe'=>'提供2022已上映好看的电影排行榜、电视剧排行榜，动漫排行榜等。'],
        ];
        //广告
        $poster = [
            'footer_pc'=>'<a href="/maccms/cps/?type=douyin" target="_blank"><img class="img-fluid" src="https://cdn.daicuo.cc/images/cps/douyin97090.png" alt="doubi"></a>',
            'center_wap'=>'<a class="btn btn-block btn-info text-light" href="/maccms/cps/?type=douyin" target="_blank">抖音币充值，最低8折抢购中</a>',
        ];
        return \daicuo\Op::write([
            'api_search'      => 't2s',
            'api_url'         => 'http://cdn.feifeicms.co/api/hao124/index.php',
            'api_type'        => 'feifeicms',
            'api_params'      => '',
            'page_size'       => 30,
            'theme'           => 'default_pc',
            'theme_wap'       => 'default_wap',
            'site_title'      => '2022最新免费电影',
            'site_keywords'   => '2022最新电影,2022免费电影,2022好看电视剧',
            'site_description'=> '青苹果API影视系统提供2022年最新好看的免费电影与电视剧。',
            'limit_index'     => 16,
            'limit_categorys' => 6,
            'slide_index'     => json_encode($slide_index),
            'slide_index_m'   => json_encode($slide_index),
            'link_index'      => json_encode($link_index),
            'link_footer'     => json_encode($link_footer),
            'footer_pc'       => $poster['footer_pc'],
            'center_wap'      => $poster['center_wap'],
            'rewrite_index'   => 'maccms$',
            'rewrite_play'    => 'video/:termSlug/<id>-<ep>-<from>',
            'rewrite_category'=> 'video/:slug/[:pageNumber]',
        ], 'maccms', 'config', 'system', 0, 'yes');
    }
    
    //批量添加路由伪静态
    public function insertRoute()
    {
        config('common.validate_name', false);
        
        config('common.validate_scene', false);
        
        config('common.where_slug_unique', false);
        
        return \daicuo\Route::save_all([
            [
                'rule'        =>'maccms$',
                'address'     =>'maccms/index/index',
                'method'      =>'get',
                'op_module'   =>'maccms',
            ],
            [
                'rule'        =>'video/:termSlug/<id>-<ep>-<from>',
                'address'     =>'maccms/play/index',
                'method'      =>'get',
                'op_module'   =>'maccms',
            ],
            [
                'rule'        =>'video/:slug/[:pageNumber]',
                'address'     =>'maccms/category/index',
                'method'      =>'get',
                'op_module'   =>'maccms',
            ],
        ]);
    }
    
    //批量添加分类
    public function insertCategory()
    {
        config('common.validate_name', false);
        
        config('common.validate_scene', false);
        
        config('common.where_slug_unique', [
            'term_module' => ['eq','maccms'],
        ]);
        
        //扩展分类表字段
        DcConfigMerge('custom_fields.term_meta', [
            'term_limit',
            'term_api_tid',
            'term_api_type',
        ]);
        
        //添加一级分类
        return $this->insertTerm([
            '电影'   => 1,
            '电视剧' => 2,
            '动漫'   => 3,
            '综艺'   => 4,
        ]);
    }
    
    /**
     * 批量添加标签或分类
     * @version 1.2.0 首次引入
     * @param array $post 必需;数组格式,支持的字段列表请参考手册;默认：空
     * @return mixed $mixed 成功时返回obj,失败时null
     */
    private function insertTerm($post=[])
    {
        $default = [
            'term_name'       => '电影',
            'term_slug'       => 'dianying',
            'term_module'     => 'maccms',
            'term_controll'   => 'category',
            'term_action'     => 'index',
            'term_type'       => 'category',
            'term_status'     => 'normal',
            'term_order'      => 2,
            'term_info'       => '免费电影在线观看',
            'term_parent'     => 0,
            'term_navbar'     => 'yes',
            'term_tpl'        => '',
            'term_limit'      => 30,
            'term_api_tid'    => 1,
            'term_api_type'   => 'Feifeicms',
        ];
        $list = [];
        foreach($post as $key=>$value){
            array_push($list, DcArrayArgs([
                'term_name'    => $key,
                'term_slug'    => DcPinYin($key),
                'term_info'    => '免费'.$key,
                'term_api_tid' => $value,
            ], $default));
        }
        return \daicuo\Term::save_all($list);
    }
}